<xsl:stylesheet 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   version="1.0">

<xsl:key name="pub" match="book" use="publisher"/>

<xsl:variable name="publishers" 
   select="//publisher[not(.=preceding::publisher)]"/>

<xsl:template match="/">
<html>
<head>
   <title>Sales volume by publisher</title>
</head>
<body>
   <h1>Sales volume by publisher</h1>
   <table>
      <tr>
      <th>Publisher</th><th>Total Sales Value</th>
      </tr>
   <xsl:for-each select="$publishers">
      <tr>
         <td><xsl:value-of select="."/></td>
         <td><xsl:call-template name="total-sales"/></td>
      </tr>
   </xsl:for-each>
   </table>
</body>
</html>
</xsl:template>

<!-- calculate total book sales for the current publisher -->
<xsl:template name="total-sales">
   <xsl:value-of select="sum(key('pub',string(.))/sales)"/>
</xsl:template>
</xsl:stylesheet>
